
eval '(exit $?0)' && eval 'exec perl -S $0 ${1+"$@"}'
& eval 'exec perl -S $0 $argv:q'
if 0;

### Make sure copyurl is in path, or set full path here:
$GETURL = "copyurl -s";
&init;

### Memo files to generate:
mkdir("$SM/Personal",0755) unless (-d "$SM/personal");
$WEATHER = "$SM/Personal/weather.txt";
$MOVIES = "$SM/Personal/movies.txt";
$THELIST = "$SM/Personal/thelist.txt";

#
# Weather report
#
if (&OutOfDate($WEATHER, 0.2) && !fork)
{
    @new_weather = split(/\015?\n/,
	`$GETURL http://www.wunderground.com/forecasts/SJC.html`);
 
    foreach $line (@new_weather)
    {
	if ($citytemps) {
	    do { $citytemps = 0; $new_weather .= "\n"; next }
		 unless ($line =~ /^[A-Z]/);
	    next unless ($line =~ /^Mountain/ || $line =~ /^San Jose/);
	}
	next unless ($line);
	$line =~ s/^<title>//;
	$line = "Temperature: $line" if ($line =~ s|&#176;||);
	$line = "Humidity: $line" if ($line =~ m|%</|);
	$line = "Wind: $line\n" if ($line =~ m| mph</|);
	next if ($line =~ m|^[A-Z]</FONT>|);
	do { $new_weather .= "Forecast as of "; next }
	    if ($line =~ /Forecast as of/);
	$line =~ tr/a-z/A-Z/ if ($line =~ s|^.*size="\+2">(.)</font>|$1|);
	if ($line =~ s/^.<    /\n\t\t/) {
	    $line =~ s/    Precipitation/Precip/;
	    $citytemps = 1;
	}
	next if ($line =~ /^ *</ || $line =~ /^alt="/);
	$line =~ s/<[^>]*>//g;
	$line =~ s/ +$//;
	$new_weather .= "$line\n";
    }
 
    &Update($WEATHER, $new_weather);
    exit;
}

#
# Century Theaters movie listings
#
if (&OutOfDate($MOVIES) && !fork)
{
    @new_movies = split(/\015?\n/,
       `$GETURL 'http://www.centurytheatres.com/schedule/nca.htm'`);

    $new_movies = "Century Theaters\n\n";
    foreach $line (@new_movies)
    {
	if ($skip) { $skip--; next }
	next unless ($mtv || $line =~ /NAME="anchor17".*Century/);
	unless ($mtv) {
	    $line = "CENTURY CINEMA";
	    $mtv = 1; $max = 3; $skip = 1;
	}

	$line =~ s/<BR>//g;
	$blank++ unless ($line);
	next unless ($blank < $max || $line =~ /NAME="anchor03".*Century/);
	if ($blank >= $max) {
	    $line = "CENTURY 21-25";
	    $blank = 0; $max = 5; $skip = 1;
	}

	$line =~ s/<[^>]*>//g;
	$new_movies .= "$line\n";
    }

    &Update($MOVIES, $new_movies);
    exit;
}

#
# TheList concerts
#
if (&OutOfDate($THELIST) && !fork)
{
    @new_concerts = split(/\015?\n/,
       `$GETURL 'http://www.luini.com/mail2/thelist.html'`);

    chop($date = `date "+%b %e %a"`);
    $date =~ tr/A-Z/a-z/;
    $date =~ s/  / /;
    $new_concerts = "Concerts - funk-punk-thrash-ska\n" if (@new_concerts);

    foreach $line (@new_concerts)
    {
	next unless ($now || $line =~ /<H3>$date</);
	$now = 1 unless ($now);

	$cap = ($line =~ /^<TR>.*<H3>/);
	$days++ if ($cap);
	next if ($days > 8);

	$line =~ s/<[^>]*>//g;
	next unless ($line);
	if ($cap) {
	    $line =~ tr/a-z/A-Z/;
	    $line = "\n$line";
	}
	$line =~ s/^  /     /;
	$new_concerts .= "$line\n";
    }

    &Update($THELIST, $new_concerts);
    exit;
}

#
# Does file need to be updated?
#
sub OutOfDate
{
    my ($FILE, $expire) = @_;
    $expire = 0.6 unless ($expire);
    return 1 if (! -f "$FILE" || (-M "$FILE" > $expire));
    return 0;
}

#
# General File update routine
#
sub Update
{
    my ($FILE, $new_text) = @_;
    my ($date, $time, $fname);

    if ($new_text)
    {
	open(FD, ">$FILE") ||
	    print STDERR "Unable to open $FILE for write\n";
	print FD $new_text;
	close(FD);
    } else {
	$date = `date "+%I:%M:%S %p   %a %D"`;
	$fname = $FILE;
	$fname =~ s|^.+(/[^/]+/[^/]+)$|...$1|;
	open(FD, ">>$FILE") ||
	    print STDERR "Unable to open $FILE for append\n";
	print FD "Unable to retrieve/process $fname at $date";
	close(FD);
	print STDERR "Unable to retrieve/process $fname at $date";
	$time = time - 365*24*60*60;	# set time back so another attempt
	utime($time, $time, $FILE);	# will be made on next update
    }
}

wait;
wait;
wait;
exit;

sub init
{
 die "Error reading SyncMemo preferences file:\n\
~/.pilotmgr/SyncMemo/SyncMemo.prefs\n"
    if (! -f "$ENV{HOME}/.pilotmgr/SyncMemo/SyncMemo.prefs");

 eval `cat $ENV{HOME}/.pilotmgr/SyncMemo/SyncMemo.prefs`;
 $PREFS;
 die "No setting for Memo Directory found in SyncMemo preferences.\n"
    unless(defined($PREFS->{gHomeDirectory}));

 $SM = $PREFS->{gHomeDirectory};

 die "Memo directory from SyncMemo preferences doesn't exist:\n$SM\n"
    unless(-d $SM);

 my ($fn) = split(/ /, $GETURL);
 if ($fn =~ m|/|) {
   die "copyurl program not found ($fn)\n" unless (-x $fn);
 } else {
   $fn = `which $fn`;
   die "copyurl program not found ($fn)\n" if ($fn =~ /^no /);
 }
}

